package net.sf.doolin.bus;

/**
 * Trigger for a subscriber.
 * 
 * @author Damien Coraboeuf
 * 
 */
public interface SubscriberTrigger<M> {

	/**
	 * Gets the class that this subscriber accepts to handle
	 */
	Class<M> getMessageClass();

    /**
     * Checks the message
     */
    boolean accept (M message);

	/**
	 * Description for the trigger
	 */
	String getTriggerDescription();

}
