package net.sf.doolin.bus.sido;

import net.sf.doolin.bus.bean.IBean;
import net.sf.doolin.bus.support.PropertyChangeSupport;
import net.sf.sido.DataObject;
import net.sf.sido.ParentLink;
import net.sf.sido.support.DataObjectControllerAdapter;

public class BusDataObjectController extends DataObjectControllerAdapter {

	@Override
	public <T> void onPropertySetPost(DataObject sdo, String name, T oldValue,
			T newValue) {
		// Publishes the change
		PropertyChangeSupport.change(sdo, name, oldValue, newValue);
		// Parent management
		ParentLink link = sdo.getParentLink();
		while (link != null) {
			Object o = link.getParent();
			name = link.getParentProperty() + "." + name;
			if (o instanceof DataObject) {
				PropertyChangeSupport.change(o, name, oldValue, newValue);
				link = ((DataObject) o).getParentLink();
			} else if (o instanceof IBean) {
				((IBean) o).getBeanNotificationSupport().notify(name, oldValue,
						newValue);
				link = null;
			} else {
				link = null;
			}
		}
	}
}
