package net.sf.doolin.bus.support;

import net.sf.doolin.bus.IBusInfo;
import net.sf.doolin.bus.ISubscriptionClassInfo;

import java.util.ArrayList;
import java.util.List;

public class BusInfo implements IBusInfo {

    private int pendingMessages;
    private final List<ISubscriptionClassInfo> subscriptionClassInfos = new ArrayList<ISubscriptionClassInfo>();

    @Override
    public int getPendingMessages() {
        return pendingMessages;
    }

    @Override
    public List<ISubscriptionClassInfo> getSubscriptionClassInfos() {
        return subscriptionClassInfos;
    }

    @Override
    public int getSubscriptionCount() {
        int count = 0;
        for (ISubscriptionClassInfo subscriptionClassInfo : subscriptionClassInfos) {
            count += subscriptionClassInfo.getSubscriptionInfos().size();
        }
        return count;
    }

    public void setPendingMessages(int pendingMessages) {
        this.pendingMessages = pendingMessages;
    }

    public void addSubscriptionClassInfo(ISubscriptionClassInfo subscriptionClassInfo) {
        subscriptionClassInfos.add(subscriptionClassInfo);
    }
}
