package net.sf.doolin.bus.support;

import net.sf.doolin.bus.Subscriber;

/**
 * This {@link net.sf.doolin.bus.BusLog} logs all bus messages on the Standard
 * Error. Any bus error message is associated with its stack trace.
 *
 * @author Damien Coraboeuf
 * @see System#err
 */
public class SysErrBusLog extends AbstractTextBusLog {

    @Override
    protected void log(String text) {
        System.err.println(text);
    }

    @Override
    public <M> void messageWithError(M message, Subscriber<M> subscriber,
                                     Exception ex) {
        super.messageWithError(message, subscriber, ex);
        ex.printStackTrace(System.err);
    }

}
